{% extends 'timetracker/base.html' %}
{% load i18n medux %}

{% block page-title %}{% translate 'Working time entries' %}{% endblock %}

{% block content %}
    {% with current_month=month|date:"n" current_month_name=month|date:"F" current_year=month|date:"Y"  %}
        <div class="card"
             id="time-entries-month"
             hx-get="{{ request.path }}"
             hx-trigger="timetracker:monthlytimebilling:created from:body, timetracker:absence:changed from:body, timetracker:absence:deleted from:body"
             hx-select="#time-entries-month"
             hx-swap="outerHTML"
             hx-disinherit="*"
        >
            <div class="card-header{% if submitted %} bg-light{% endif %}">
                <div>

                    <h3 class="card-title">
                        {{ month|date:"F" }} {{ current_year }}
                    </h3>

                    <div class="card-subtitle">
                        {#            <div>{% translate 'Time account'%}: {{ time_account_balance }} {% translate 'hours' %}</div>#}
                        {% translate 'Target hours' context 'for month' %}: <span class="text-black strong">{{ month_target_working_time|as_hours }}</span> {% translate 'hours' %},
                        {% if submitted %}
                            {% translate 'worked:' context 'worked hours' %}
                        {% else %}
                            {% translate 'currently' context 'currently worked hours' %}
                        {% endif %}
                        <span class="text-black strong">{{ month_current_working_time|as_hours }}</span>  {% translate 'hours' %}
                        {% if month_working_time_delta %}({{ month_working_time_delta|as_hours|prefix_plus }}){% endif %}
                        <div class="progress">
                            <div class="progress-bar" style="width: {{ month_current_working_time_percent }}%" role="progressbar" aria-valuenow="{{ month_current_working_time|as_hours }}" aria-valuemin="0" aria-valuemax="{{ month_target_working_time|as_hours }}">
                                <span class="visually-hidden">{{ month_current_working_time|as_hours }}</span>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="card-actions">
                    {% url "timetracker:timeentry:month-list" prev_month|date:"Y" prev_month|date:"n" as url %}
                    <button
                            class="btn btn-action"
                            hx-get="{{ url }}"
                            hx-target="#time-entries-month"
                            hx-select="#time-entries-month"
                            hx-push-url="{{ url }}"
                            hx-swap="outerHTML"
                            title="{{ prev_month|date:"F" }} {{ prev_month|date:"Y" }}"
                    ><i class="bi bi-arrow-left"></i></button>

                    {% url "timetracker:timeentry:month-list" today|date:"Y" today|date:"n" as url %}
                    <button
                            class="btn btn-action"
                            hx-get="{{ url }}"
                            hx-target="#time-entries-month"
                            hx-select="#time-entries-month"
                            hx-push-url="{{ url }}"
                            hx-swap="outerHTML"
                            title="{{ today|date:"F" }} {{ today|date:"Y" }}"><i class="bi bi-calendar"></i></button>

                    {% url 'timetracker:timeentry:month-list' next_month|date:"Y" next_month|date:"n" as url %}
                    <button
                            class="btn btn-action me-2"
                            hx-get="{{ url }}"
                            hx-target="#time-entries-month"
                            hx-select="#time-entries-month"
                            hx-push-url="{{ url }}"
                            hx-swap="outerHTML"
                            title="{{ next_month|date:"F" }} {{ next_month|date:"Y" }}"
                    ><i class="bi bi-arrow-right"></i></button>
                </div>
            </div>

            <div class="table-responsive"
                 hx-trigger="timetracker:timeentry:changed from:body"
                 hx-get="{% url 'timetracker:timeentry:month-list' current_year current_month %}"
                 hx-target="#time-entries-month"
                 hx-select="#time-entries-month"
                 hx-swap="outerHTML"
                 hx-disinherit="*"
            >
                <table class="table table-sm card-table table-vcenter text-nowrap">
                    <thead>
                    <tr>
                        <th>{% translate 'Date' %}</th>
                        <th>{% translate 'Normal working time' %}</th>
                        <th>{% translate 'Start' %}</th>
                        <th>{% translate 'End' %}</th>
                        <th>{% translate 'Delta' %}</th>
                        <th>{% translate 'Comment' %}</th>
                        <th></th>
                    </tr>
                    </thead>
                    <tbody>
                    {% for day_entry in day_entries %}
                        {% for time_entry in day_entry.time_entries %}
                            {% with label=day_entry.absence.absence_type.translated_label %}

                                <tr class="{% if day_entry.is_public_holiday %}public text-white{% elif day_entry.is_weekend %}bg-info-lt text-dark{% elif day_entry.absence and not day_entry.absence_status_declined %}absence bg-{{ day_entry.absence.absence_type.color }} text-{{ day_entry.absence.absence_type.color }}-fg {{ day_entry.absence.status }}{% endif %}{% if day_entry.today %} today{% endif %}"
                                >
                                    <td class="p-0{% if forloop.revcounter != 1 %} border-bottom-0{% endif %}"
                                        title="{% blocktranslate %}{{ label }} declined{% endblocktranslate %}"
                                    >
                                        {% ifchanged day_entry.date %}
                                            <div class="d-flex ps-2 align-items-center">
                                                <div class="ms-1 me-2 p-1 border border-2 rounded-2 bg-white text-muted">{{ day_entry.date|date:"d" }}</div>
                                                <div class="p-2" style="width:3rem; text-align: center;">
                                                    {{ day_entry.date|date:"D" }}
                                                </div>
                                                {% if day_entry.absence_status_declined %}
                                                    <i class="bi bi-dash-square-fill text-{{ day_entry.absence.absence_type.color }} fs-2"></i>
                                                {% endif %}
                                                {# TODO show 2 icons if e.g. holiday AND illness are declined #}
                                            </div>
                                        {% endifchanged %}
                                    </td>
                                    <td class="{% if forloop.revcounter != 1 %} border-bottom-0{% endif %}">
                                        <div class="title">
                                            {% ifchanged day_entry.date %}
                                                {% if day_entry.absence and not day_entry.absence_status_declined %}
                                                    {% if day_entry.absence_status_approved or day_entry.is_CTO %}
                                                        ({{ label }})
                                                    {% elif day_entry.absence_status_requested %}
                                                        {% blocktranslate %}{{ label }} requested{% endblocktranslate %}
                                                    {% endif %}

                                                {% elif day_entry.is_public_holiday %}
                                                    {{ day_entry.holiday_name }}
                                                {% else %}
                                                    <span class="d-none d-md-inline">
                                                    {% for wtr in day_entry.working_time_ranges %}
                                                        {% if wtr and not day_entry.is_public_holiday %}
                                                            {% if not forloop.first %}, {% endif %}
                                                            {{ wtr.start_time }}-{{ wtr.end_time }}
                                                        {% endif %}
                                                    {% endfor %}
                                                    </span>
                                                    {% if day_entry.daily_normal_working_time %}
                                                        ({{ day_entry.daily_normal_working_time }} h)
                                                    {% endif %}
                                                {% endif %}
                                            {% endifchanged %}
                                        </div>
                                    </td>
                                    <td class="{% if forloop.revcounter != 1 %}border-bottom-0{% endif %}">
                                        {% if time_entry.wtr == wtr %}
                                            {{ time_entry.start|time|default:"" }}
                                        {% endif %}
                                    </td>
                                    <td class="{% if forloop.revcounter != 1 %}border-bottom-0{% endif %}{% if time_entry.start and not time_entry.end %} bg-warning-lt{% endif %}">
                                        {% if time_entry.wtr == wtr %}
                                            {{ time_entry.end|time|default:"" }}
                                        {% endif %}
                                    </td>
                                    <td class="{% if forloop.revcounter != 1 %}border-bottom-0{% endif %}">
                                        {% ifchanged day_entry.date %}
                                            {% if time_entry %}
                                                {% with day_entry.daily_timedelta as delta %}
                                                    {% if delta %} {# is there any worked time with start/end #}
                                                        {{ delta|default:""|prefix_plus }} h
                                                    {% elif time_entry.end %} {# only show checkmark if timeentry is not open #}
                                                        <i class="bi bi-check text-lime"></i>
                                                    {% endif %}
                                                {% endwith %}
                                            {% endif %}
                                        {% endifchanged %}
                                    </td>

                                    <td class="{% if forloop.revcounter != 1 %}border-bottom-0{% endif %}">
                                        <span class="text-muted">{{ time_entry.comment }}</span>
                                    </td>

                                    <td class="text-end{% if forloop.revcounter != 1 %} border-bottom-0{% endif %}">
                                        {% if not submitted %}
                                            {% if day_entry.working_time_ranges and not time_entry.id and not day_entry.absence %}
                                                <button class="btn btn-action{% if day_entry.is_missing %} bg-warning-lt{% endif %}"
                                                        hx-post="{% url 'timetracker:timeentry:complete' %}?date={{ day_entry.date|date:'Y-m-d' }}"
                                                        hx-target="#dialog"
                                                        title="{% translate 'Fill out time entries automatically' %}"
                                                ><i class="bi bi-check-lg"></i></button>
                                            {% endif %}
                                            {% if time_entry.id %}
                                                <button class="btn btn-action"
                                                        hx-get="{% url 'timetracker:timeentry:update' time_entry.id %}"
                                                        hx-target="#dialog"
                                                ><i class="bi bi-pencil"></i></button>
                                                <button class="btn btn-action"
                                                        hx-get="{% url 'timetracker:timeentry:delete' time_entry.id %}"
                                                        hx-target="#dialog"
                                                ><i class="bi bi-trash"></i></button>
                                            {% endif %}
                                            {% ifchanged day_entry.date %}
                                                {% if not day_entry.is_employee_holiday and not day_entry.absence %}
                                                    <button
                                                            class="btn btn-action{% if day_entry.is_missing %} bg-warning-lt{% endif %}"
                                                            hx-get="{% url 'timetracker:timeentry:add'%}?date={{ day_entry.date|date:'Y-m-d' }}{% if day_entry.working_time_ranges %}&start_time={{ day_entry.working_time_ranges.0.start_time }}&end_time={{ day_entry.working_time_ranges.0.end_time }}{% endif %}"
                                                            hx-target="#dialog"
                                                            title="{% translate 'Add time entry' %}"
                                                    ><i class="bi bi-plus-lg"></i></button>
                                                {% else %}
                                                    <button class="btn btn-action disabled bg-transparent cursor-default">&nbsp;</button>
                                                {% endif %}
                                                {% if day_entry.actions_enabled %}
                                                    <div class="dropdown d-inline-block">
                                                        <button class="btn btn-action dropdown-toggle"
                                                                type="button"
                                                                href="#"
                                                                id="dropdown-action-{{ day_entry.date.isoformat }}"
                                                                data-bs-toggle="dropdown"
                                                                aria-expanded="false"
                                                                {% if not day_entry.actions_enabled %} disabled{% endif %}
                                                        >
                                                            <i class="bi bi-three-dots-vertical"></i>
                                                        </button>
                                                        <div class="dropdown-menu" aria-labelledby="dropdown-action-{{ day_entry.date.isoformat }}">
                                                            {% if day_entry.absence %}

                                                                <a class="dropdown-item{% if day_entry.absence_status_approved and day_entry.absence.absence_type.needs_approval or day_entry.absence_status_declined %} disabled{% endif %}"
                                                                   href="#"
                                                                   hx-post="{% url 'timetracker:absence:cancel' pk=day_entry.absence.pk %}"
                                                                >
                                                                    {% translate 'Cancel' context "cancel absence" %}
                                                                </a>

                                                            {% else %} {# no absence on this day, create absence items #}
                                                                {% for absence_type in absence_types %}
                                                                    <a class="dropdown-item"
                                                                       href="#"
                                                                       hx-post="{% url 'timetracker:absence:request' year=day_entry.date.year month=day_entry.date.month day=day_entry.date.day absence_type=absence_type.uuid %}">
                                                                        {{ absence_type.translated_label }}
                                                                    </a>
                                                                {% endfor %}
                                                            {% endif %}
                                                        </div>
                                                    </div>
                                                {% else %}
                                                    <button class="btn btn-action disabled bg-transparent cursor-default">&nbsp;</button>
                                                {% endif %}
                                            {% else %}
                                                {# Add 2 disabled buttons, just for spacing#}
                                                <button class="btn btn-action disabled bg-transparent cursor-default">&nbsp;</button>
                                                <button class="btn btn-action disabled bg-transparent cursor-default">&nbsp;</button>
                                            {% endifchanged %}
                                        {% endif %}
                                    </td>
                                </tr>
                            {% endwith %}
                        {% endfor %}
                    {% endfor %}
                    </tbody>
                </table>
            </div>
            {% if allow_submitting %}
                <div class="card-footer">
                    {% url 'timetracker:monthlytimebilling' current_year current_month as url %}
                    <button class="btn{% if not submitted %} btn-warning{% endif %}"
                            {% if submitted or not all_absences_approved %}
                            disabled
                            {% else %}
                            hx-get="{{ url }}"
                            hx-target="#dialog"
                            {% endif %}
                            title="{% blocktranslate %}Finalize and Submit {{ current_month_name }} {{ current_year }} to employer{% endblocktranslate %}"
                    ><i class="bi bi-calendar-check me-2"></i>
                        {% if submitted %}
                            {% translate 'Month already submitted to employer' %}
                        {% elif not all_absences_approved %}
                            {% translate 'Please make sure all absences are approved before submitting.' %}
                        {% else %}
                            {% translate 'Submit month data to employer' %}
                        {% endif %}

                    </button>
                </div>
            {% endif %}
        </div>
    {% endwith %}
{% endblock %}